name: "schedule/docker"

on:
  schedule:
    - cron: '0 6 * * 1'

jobs:
  lint:
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v4

      - name: Set Swap Space
        uses: pierotofy/set-swap-space@49819abfb41bd9b44fb781159c033dba90353a7c
        with:
          swap-size-gb: 12

      - name: Run Golangci lint
        uses: golangci/golangci-lint-action@v3
        with:
          version: latest
          args: --print-resources-usage

  build:
    name: "build ${{ matrix.Dockerfile }}:${{ matrix.target }}"
    needs: lint
    strategy:
      fail-fast: false
      matrix:
        include:
          -
            Dockerfile: Dockerfile
            target: "final-ubuntu"
            suffix: "-ubuntu"
            latest: "auto"
          -
            Dockerfile: Dockerfile
            target: "final-alpine"
            suffix: "-alpine"
            latest: false
          -
            Dockerfile: Dockerfile
            target: "final-debian"
            suffix: "-debian"
            latest: false
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v4

      - name: Set Swap Space
        uses: pierotofy/set-swap-space@master
        with:
          swap-size-gb: 12

      - name: Docker meta
        id: docker_meta
        uses: docker/metadata-action@v5
        with:
          images: ${{ github.repository }},quay.io/${{ github.repository }}
          labels: |
            io.artifacthub.package.readme-url=https://raw.githubusercontent.com/${{ github.repository }}/${{ github.event.repository.default_branch }}/README.md
          flavor: |
            latest=${{ matrix.latest }}
            suffix=${{ matrix.suffix }}

      - name: Set up QEMU
        uses: docker/setup-qemu-action@v3

      - name: Set up Docker Buildx
        uses: docker/setup-buildx-action@v3

      - name: Login to DockerHub
        uses: docker/login-action@v3
        with:
          username: ${{ secrets.DOCKERHUB_USERNAME }}
          password: ${{ secrets.DOCKERHUB_TOKEN }}

      - name: Login to Quay
        uses: docker/login-action@v3
        with:
          registry: quay.io
          username: ${{ secrets.QUAY_USERNAME }}
          password: ${{ secrets.QUAY_TOKEN }}

      - name: Build and push
        uses: docker/build-push-action@v5
        with:
          context: .
          file: ./${{ matrix.Dockerfile }}
          target: ${{ matrix.target }}
          platforms: linux/amd64,linux/arm64
          push: ${{ github.event_name != 'pull_request' }}
          tags: ${{ steps.docker_meta.outputs.tags }}
          labels: ${{ steps.docker_meta.outputs.labels }}
